#define INITGUID

#include <windows.h>
#include <stdio.h>
#include "imath.h"
#include "UUID.h"


int WINAPI
WinMain(HINSTANCE  hInstance, HINSTANCE  hPrevInstance,	

            LPSTR  lpszCmdLine, int  nCmdShow ) {

   LPUNKNOWN punk;
   LPMATH pMath;
   LPPERSIST pPersist;
   HRESULT hr;

   hr = CoInitialize(NULL);

   hr = ::CoCreateInstance(CLSID_CoMath, NULL, 
                           CLSCTX_INPROC_SERVER, 
                           IID_IUnknown,
                           (VOID FAR **)&punk);

   if(SUCCEEDED(hr)) {
      hr = punk->QueryInterface(IID_IMath, (LPVOID FAR*)&pMath);

      if(SUCCEEDED(hr)) {
         CLSID clsid;
         LPOLESTR szClassName;

         hr = punk->QueryInterface(IID_IPersist, (LPVOID FAR*)&pPersist);
         if(pPersist) {
            hr = pPersist->GetClassID(&clsid);
            hr = StringFromCLSID(clsid, &szClassName);

            pPersist->Release();
            ::CoFreeUnusedLibraries();
         }

         LONG lSum, lDifference;
         char s[80];

         hr = pMath->Add(10, 50, &lSum);
         hr = pMath->Subtract(150, 50, &lDifference);

         sprintf(s, "Sum: %ld, Difference: %ld",
                 lSum, lDifference);

         ::MessageBox(0, s, "Results of using CoMath:", MB_OK);
         
         LPMALLOC pMalloc;
         ::CoGetMalloc(MEMCTX_TASK, &pMalloc);

         pMalloc->Free((void *)szClassName);

         pMalloc->Release();

         pMath->Release();
         ::CoFreeUnusedLibraries();
      }

      punk->Release();
      ::CoFreeUnusedLibraries();
   }

   CoUninitialize();

   return 0;
}	
