// browdlg.cpp : implementation file
//

#include "stdafx.h"
#include "objfun.h"
#include "browdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBrowseDialog dialog


CBrowseDialog::CBrowseDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CBrowseDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBrowseDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
    m_pClass = NULL;
}

void CBrowseDialog::SetNewClass(CRuntimeClass * pClass)
{
    m_pClass = pClass;
}

void CBrowseDialog::Browse()
{
    ASSERT(m_pClass != NULL);
    char buffer[256];
    
    CEdit * pEdit;
    CButton * pButton;
    
    //ClassName
    pEdit = (CEdit *)GetDlgItem(IDC_CLASSNAME);
    pEdit->SetWindowText(m_pClass->m_lpszClassName);
    
    //ObjectSize
    pEdit = (CEdit *)GetDlgItem(IDC_OBJECTSIZE);
    sprintf(buffer,"%d",m_pClass->m_nObjectSize);
    pEdit->SetWindowText(buffer);
    
    //Schema
    pEdit = (CEdit *)GetDlgItem(IDC_SCHEMA);
    sprintf(buffer,"%x",m_pClass->m_wSchema);
    pEdit->SetWindowText(buffer);
    
    //BaseClass
    pEdit = (CEdit *)GetDlgItem(IDC_BASECLASS);
    pButton = (CButton *)GetDlgItem(IDC_BASEBUTTON);
    
#ifdef _AFXDLL
    CRuntimeClass * pBase = m_pClass->m_pfnGetBaseClass();
#else
    CRuntimeClass * pBase = m_pClass->m_pBaseClass;
#endif
    if (pBase != NULL){
	pEdit->SetWindowText(pBase->m_lpszClassName);
	pButton->EnableWindow(TRUE);
    }
    else {
	pEdit->SetWindowText("No Base");
	pButton->EnableWindow(FALSE);
    }
    
    //NextClass
    pEdit   = (CEdit *)GetDlgItem(IDC_NEXTCLASS);
    pButton = (CButton *)GetDlgItem(IDC_NEXTBUTTON);
    
    if (m_pClass->m_pNextClass != NULL){
	pEdit->SetWindowText(m_pClass->m_pNextClass->m_lpszClassName);
	pButton->EnableWindow(TRUE);
    } else {
	pEdit->SetWindowText("No Next");
	pButton->EnableWindow(FALSE);
    }

    //Update title of dialog
    sprintf(buffer,"Browsing class %s CRuntime data",
	    m_pClass->m_lpszClassName);
    SetWindowText(buffer);
}

void CBrowseDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBrowseDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBrowseDialog, CDialog)
	//{{AFX_MSG_MAP(CBrowseDialog)
	ON_BN_CLICKED(IDC_BASEBUTTON, OnBasebutton)
	ON_BN_CLICKED(IDC_NEXTBUTTON, OnNextbutton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CBrowseDialog message handlers

BOOL CBrowseDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	Browse();	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CBrowseDialog::OnBasebutton() 
{
#ifdef _AFXDLL
    CRuntimeClass * pBase = m_pClass->m_pfnGetBaseClass();
#else
    CRuntimeClass * pBase = m_pClass->m_pBaseClass;
#endif

    SetNewClass(pBase);
    Browse();   
}

void CBrowseDialog::OnNextbutton() 
{   
    SetNewClass(m_pClass->m_pNextClass);
    Browse();
}
