// internal.cpp : implementation file
//

#include "stdafx.h"
#include "objfun.h"
#include "internal.h"
#include "browdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


static void RuntimeClassToString(char * pBuffer, CRuntimeClass * pClass);
static void AddObjectsToList(CObject * pObject, void * pContext);

/////////////////////////////////////////////////////////////////////////////
// CInternalDialog dialog


CInternalDialog::CInternalDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CInternalDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInternalDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
    m_nMode = 0;
}


void CInternalDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInternalDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInternalDialog, CDialog)
	//{{AFX_MSG_MAP(CInternalDialog)
	ON_BN_CLICKED(IDCLASS, OnClass)
	ON_BN_CLICKED(IDOBJECTS, OnObjects)
	ON_LBN_DBLCLK(IDC_LIST1, OnDblclkList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CInternalDialog message handlers

void CInternalDialog::OnClass() 
{
    //Get a pointer to the listbox
    CListBox * pListbox = (CListBox *)GetDlgItem(IDC_LIST1);
    ASSERT(pListbox != NULL);
    m_nMode = 1;
    pListbox->ResetContent(); //CLEAR!
    
    //Now lets fill that puppy up with some neato info
    
    // just walk through the simple list of registered classes
    AFX_CORE_STATE* pCoreState = AfxGetCoreState();
    for (CRuntimeClass* pClass = pCoreState->m_pFirstClass; pClass != NULL;
	 pClass = pClass->m_pNextClass)
	AddRuntimeClassToList(pListbox,pClass);   

}

void CInternalDialog::AddRuntimeClassToList(CListBox * pList, CRuntimeClass * pClass)
{
    ASSERT(pList != NULL);
    ASSERT(pClass != NULL);
    char buffer[256];

    RuntimeClassToString(buffer,pClass);
    //Store the pointer to the CRuntimeClass for clicking.
    int nIndex = pList->InsertString(-1,buffer);
    pList->SetItemDataPtr(nIndex,pClass);
    
}

void CInternalDialog::OnObjects() 
{
    CListBox * pListbox = (CListBox *)GetDlgItem(IDC_LIST1);
    ASSERT(pListbox != NULL);
    m_nMode = 2;
    pListbox->ResetContent(); //CLEAR!
    
    AfxDoForAllObjects(AddObjectsToList,pListbox);
}

void CInternalDialog::OnDblclkList1() 
{
	CBrowseDialog browseDialog;
	
	CListBox * pListbox = (CListBox *)GetDlgItem(IDC_LIST1);
	ASSERT(pListbox != NULL);
	
	int nIndex = pListbox->GetCurSel();

	ASSERT(nIndex != LB_ERR);
	CRuntimeClass * pClass =
	    (CRuntimeClass *)pListbox->GetItemDataPtr(nIndex);
	ASSERT(pClass != NULL);
	browseDialog.SetNewClass(pClass);
	browseDialog.DoModal();
		
}

static void RuntimeClassToString(char * pBuffer, CRuntimeClass * pClass)
{   
#ifdef _AFXDLL
    CRuntimeClass * pBase = pClass->m_pfnGetBaseClass();
    
    if (pBase != NULL){
	sprintf(pBuffer,"%s\t%d\t%x\t%s",
		pClass->m_lpszClassName,
		pClass->m_nObjectSize,
		pClass->m_wSchema,
		pBase->m_lpszClassName);
	return;
    }
#else  //!_AFXDLL
    CRuntimeClass * pBase = pClass->m_pBaseClass;
    
    if (pBase != NULL){
	sprintf(pBuffer,"%s\t%d\t%x\t%s",
		pClass->m_lpszClassName,
		pClass->m_nObjectSize,
		pClass->m_wSchema,
		pBase->m_lpszClassName);
	return;
    }
#endif //End _AFXDLL
    //If we get here, there's no base class
    sprintf(pBuffer,"%s\t%d\t%x\t%s",
	    pClass->m_lpszClassName,
	    pClass->m_nObjectSize,
	    pClass->m_wSchema,
	    "no base");    
}


static void AddObjectsToList(CObject * pObject, void * pContext)
{
    char buffer[256];
    ASSERT(pObject != NULL);
    ASSERT(pContext != NULL);
    
    CListBox * pList = (CListBox *)pContext;
    CRuntimeClass * pClass = pObject->GetRuntimeClass();
    
    ASSERT( pClass != NULL);
    RuntimeClassToString(buffer,pClass);
    int nIndex = pList->InsertString(-1,buffer);
    pList->SetItemDataPtr(nIndex,pObject);    
}

   
